# Copyright (c) 2000-2011, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_with gcj_support
%bcond_without repolib

%if %with gcj_support
%define gcj_support 1
%else
%define gcj_support 0
%endif

%define namedversion %{version}

%define repodir %{_javadir}/repository.jboss.com/javax/xml/soap/saaj-api/%{namedversion}-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

%define section free
%define saajver %{version}

Name:           sun-saaj-1.3-api
Version:        1.3
Release:        6%{?dist}
Epoch:          0
Summary:        SAAJ API 1.3
License:        CDDL
Group:          Development/Libraries/Java
URL:            https://jax-ws-sources.dev.java.net/
Source0:        http://download.java.net/maven/1/javax.xml.soap/java-sources/saaj-api-1.3-sources.jar
Source1:        http://download.java.net/maven/1/javax.xml.soap/poms/saaj-api-1.3.pom
Source2:        CDDLv1.0.html
Source3:        sun-saaj-1.3-api-manifest.mf
Source4:        sun-saaj-1.3-api-build.properties
Source5:        sun-saaj-1.3-api-build.xml
Source6:        sun-saaj-1.3-api-component-info.xml
Provides:       saaj_api = 0:%{saajver}
Provides:       saaj_1_3_api = 0:%{version}-%{release}
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires(post): %{_sbindir}/update-alternatives
Requires(preun): %{_sbindir}/update-alternatives
Requires:       jaf_1_1_api
Requires:       java >= 0:1.5.0
Requires:       jpackage-utils
BuildRequires:  ant
BuildRequires:  jaf_1_1_api
BuildRequires:  java-devel >= 0:1.5.0
BuildRequires:  jpackage-utils
%if %with repolib
BuildRequires:  maven2
BuildRequires:  maven2-plugin-deploy
%endif
#%if %{gcj_support}
#BuildRequires:  java-gcj-compat-devel
#%else
BuildArch:      noarch
#%endif
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
The SOAP with Attachments API for Java (SAAJ) 1.3
according to JSR-67 MR3.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation
# FIXME: (dwalluck): We can't provide this unless an alternatives symlink is also provided.
%if 0
Provides:       saaj-javadoc = 0:%{saajver}
%endif
Requires:       jpackage-utils

%description javadoc
%{summary}.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%setup -q -c 
%{__mkdir_p} src/java
%{__mv} javax src/java
%{__cp} -p %{SOURCE2} CDDLv1.0.html
%{__cp} -p %{SOURCE3} saaj.mf
%{__cp} -p %{SOURCE4} build.properties
%{__cp} -p %{SOURCE5} build.xml

%build
export CLASSPATH=$(%{_bindir}/build-classpath jaf_1_1_api 
qname_1_1_api)
export OPT_JAR_LIST=:
%{ant} -Dbuild.sysclasspath=only release

%install
%{__rm} -rf %{buildroot}

# jars
%{__mkdir_p} %{buildroot}%{_javadir}
%{__cp} -p saaj.jar %{buildroot}%{_javadir}/%{name}-%{namedversion}.jar
#%add_to_maven_depmap javax.xml.soap saaj-api %{saajver} JPP %{name}

(cd %{buildroot}%{_javadir} 
/bin/touch saaj_1_3_api.jar
/bin/touch saaj_api.jar
%{__ln_s} %{name}-%{namedversion}.jar %{name}.jar)

# javadoc
%{__mkdir_p} %{buildroot}%{_javadocdir}/%{name}-%{namedversion}
%{__cp} -pr build/release/docs/javadocs/* %{buildroot}%{_javadocdir}/%{name}-%{namedversion}
%{__ln_s} %{name}-%{namedversion} %{buildroot}%{_javadocdir}/%{name}

%if %{gcj_support}
%{_bindir}/aot-compile-rpm
%endif

%if %with repolib
%{__mkdir_p} %{buildroot}%{repodir}
%{__mkdir_p} %{buildroot}%{repodirlib}
%{__cp} -p %{SOURCE6} %{buildroot}%{repodir}/component-info.xml
tag=`/bin/echo %{name}-%{version}-%{release} | %{__sed} 's|\.|_|g'`
%{__sed} -i "s/@TAG@/$tag/g" %{buildroot}%{repodir}/component-info.xml
%{__sed} -i "s/@VERSION@/%{namedversion}-brew/g" %{buildroot}%{repodir}/component-info.xml
%{__mkdir_p} %{buildroot}%{repodirsrc}
%{__cp} -p %{SOURCE0} %{buildroot}%{repodirsrc}
%{__cp} -p %{SOURCE1} %{buildroot}%{repodirsrc}
%{__cp} -p %{SOURCE2} %{buildroot}%{repodirsrc}
%{__cp} -p %{SOURCE3} %{buildroot}%{repodirsrc}
%{__cp} -p %{SOURCE4} %{buildroot}%{repodirsrc}
%{__cp} -p %{SOURCE5} %{buildroot}%{repodirsrc}
%{__cp} -p %{buildroot}%{_javadir}/%{name}-%{namedversion}.jar %{buildroot}%{repodirlib}/saaj-api.jar
#%{__cp} -p %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}.pom %{buildroot}%{repodirlib}/saaj-api.pom
#%{_bindir}/mvn-jpp deploy:deploy-file \
#    -Dfile=%{buildroot}%{_javadir}/%{name}-%{version}.jar \
#    -DpomFile=%{buildroot}%{_datadir}/maven2/poms/JPP-%{name}.pom \
#    -Durl=file:%{buildroot}%{_javadir}/repository.jboss.com/maven2-brew \
#    -DrepositoryId=oss-releases
%endif

%clean
%{__rm} -rf %{buildroot}

%post
%{_sbindir}/update-alternatives --install %{_javadir}/saaj_1_3_api.jar saaj_1_3_api %{_javadir}/%{name}.jar 10300
%{_sbindir}/update-alternatives --install %{_javadir}/saaj_api.jar saaj_api %{_javadir}/%{name}.jar 10300
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%preun
if [ "$1" = "0" ]; then
    %{_sbindir}/update-alternatives --remove saaj_1_3_api %{_javadir}/%{name}.jar
    %{_sbindir}/update-alternatives --remove saaj_api %{_javadir}/%{name}.jar
fi

%postun
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%files
%defattr(0644,root,root,0755)
%doc CDDLv1.0.html
%{_javadir}*/%{name}-%{namedversion}.jar
%{_javadir}*/%{name}.jar
%ghost %{_javadir}*/saaj_1_3_api.jar
%ghost %{_javadir}*/saaj_api.jar
#%{_datadir}/maven2/poms/JPP-%{name}.pom
#%{_mavendepmapfragdir}/%{name}
%if %{gcj_support}
%dir %{_libdir}/gcj/%{name}
%attr(-,root,root) %{_libdir}/gcj/%{name}/%{name}-%{namedversion}.jar.*
%endif

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{namedversion}
%{_javadocdir}/%{name}

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}*
%exclude %dir %{_javadocdir}
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Wed Mar 16 2011 Yiqiao Wang <yiwang@redhat.com> 0:1.3-6
- Remove BR and R qname_1_1_api

* Fri Mar 11 2011 David Walluck <dwalluck@redhat.com> 0:1.3-5
- add MEAD repo

* Thu Sep 09 2010 David Walluck <dwalluck@redhat.com> 0:1.3-4
- fix pom name
- add Requires for update-alternatives
- fix GCJ support option

* Tue Oct 21 2009 Martha Benitez <mbenitez@redhat.com> - 0:1.3-3.1
- Add repolib and component-info.xml

* Tue Apr 21 2009 Ralph Apel <r.apel at r-apel.de> - 0:1.3-3.jpp5
- First JPP-5 release

* Fri Mar 28 2008 Ralph Apel <r.apel at r-apel.de> - 0:1.3-2jpp
- Touch, don't link, standard alternative files

* Thu Nov 08 2007 Ralph Apel <r.apel at r-apel.de> - 0:1.3-1jpp
- First release

